# uSDK服务端 SDK（For Lua）


包含SDK，及示例游戏服务器（只有最基本的功能）

适用于 Lua5.3 版本。

## 安装

安装依赖项
```shell script
sudo apt install gcc
sudo apt install lua
sudo apt install liblua5.3-dev
sudo apt install luarocks
sudo apt-get install libssl-dev
luarocks install http
luarocks install md5
```

## 游戏服务接口

> 这里是模拟的游戏服务端，提供接口给游戏客户端。

### 登录验证

* POST `/login`

  | 字段 | 说明 |
  |-----|------|
  | cUid | 渠道登录返回的用户id |
  | cName | 渠道登录返回的username |
  | accessToken | usdk登录返回的token |

* 返回

  ```
  {code: , uid: , channel: }
  ```

### 发起支付-下单

* POST `/order`

  | 字段 | 说明 |
  |-----|------|
  | uid | 游戏用户ID |
  | goodsId | 商品ID |

* 返回

  ```
  {code: , order: '游戏内订单号'}
  ```

### 支付回调

> 被 usdk 服务端调用

* POST `/payC`

  | 字段 | 说明 |
  |-----|------|
  | data | 加密的业务数据 |
  | sign | 签名 |

* 返回
  
  ```
  SUCCESS
  ```

> 如果游戏不受理此次交易，则返回 FAILED

### （游戏）商城道具列表

* GET /game_prop

* 返回:

    ```
    {code: , props:[ {key: 商品ID（须提前配置在usdk开发平台）,name: 商品名, amount: 金额（显示用）}, ... ] }
    ```

### （游戏）用户属性

