require'resource/common'
require'usdkLib/usdk'
require'usdkLib/utils'
local json = loadfile("resource/json.lua")()

function login(p)
    local cUid = p['cUid']
    local cName = p['cName']
    local accessToken = p['accessToken']
    local b,result = usdk_login(cUid, cName, accessToken)
    local t = {}
    if b==false or (result ~= nil and result['code']~=0) then
        t['code']=-1
        return json.encode(t)
    end

    local uid = result['cUid']
    local cName = result['cName']
    local channel = result['channel']
    local channelId = result['channelId']
    local gameUser = channelId .. uid

    file = io.open("game_user.json", "r")
    local GAME_USER = json.decode(file:read("*a"))
    file:close()

    local sdkuser = {}
    sdkuser['channelId'] = channelId
    sdkuser['channelUserId'] = uid
    sdkuser['cName'] = cName
    local g = {}
    g['sdkuser'] = sdkuser
    GAME_USER[gameUser] = g

    file = io.open("game_user.json", "w+")
    file:write(json.encode(GAME_USER))
    file:close()

    t['code']=0
    t['uid']=gameUser
    t['channel']=channel
    t['channelId']=channelId
    return json.encode(t)
end

function order(p)
    local uid = p['uid']
    local goodsId = p['goodsId']
	local t = {}
	t['cood'] = 0
	t['order'] = uid .. '_' .. goodsId .. '_' .. currTimestamp_seconds()
	return json.encode(t)
end

function game_prop(p)
	local arr = {}
	local i1 = {}
	i1['key']='a01'
	i1['name']='苹果'
	i1['amount']=1.0
	arr[1] = i1

	local i2 = {}
	i2['key']='a02'
	i2['name']='香蕉'
	i2['amount']=2.0
	arr[2] = i2

	local i3 = {}
	i3['key']='a03'
	i3['name']='土豆'
	i3['amount']=3.0
	arr[3] = i3

	local i4 = {}
	i4['key']='a04'
	i4['name']='草莓'
	i4['amount']=4.0
	arr[4] = i4

	local t = {}
	t['code'] = 0
	t['msg'] = '获取成功(纯演示效果，模拟获取游戏内的档位)'
	t['props'] = arr
	return json.encode(t)
end

function payC(p)
    local data = p['data']
    local sign = p['sign']
	local result = usdk_payCallback(data, sign)
	if result == nil then
		return 'FAIL'
	else
		-- TODO: 这里需要进行游戏订单的合法性校验
        -- 1、渠道id是否一致
        -- 2、用户信息是否一致
        -- 3、自定义信息是否正确
        -- 4、金额档位是否正确
        -- 5、......

        -- 模拟加档位
		gameOnPay(result)

		-- SUCCESS (注意，只有这7个字符，不能有空白或其它字符）, 如果返回其它字符会定时重新回调
		return 'SUCCESS'
	end
end

function gameOnPay(result)
    local channelId = result['channelId']
    local channelUid = result['channelUid']
    local gameUser = channelId .. channelUid

    file = io.open("game_user.json", "r")
    local GAME_USER = json.decode(file:read("*a"))
    file:close()

    local gameUserInfo = GAME_USER[gameUser]
    if gameUserInfo == nil then return end
    local goodsId = result['goodsId']

    if gameUserInfo['pack']==nil then
        local p = {}
        p[goodsId]=0
        gameUserInfo['pack'] = p
    end

    local pack = gameUserInfo['pack']
    if pack[goodsId]==nil then
        pack[goodsId] = 0
    end

    pack[goodsId] = pack[goodsId] + 1

    gameUserInfo['pack'] = pack
    GAME_USER[gameUser] = gameUserInfo

    file = io.open("game_user.json", "w+")
    file:write(json.encode(GAME_USER))
    file:close()
end

function game_user(p)
    local uid = p['uid']
    file = io.open("game_user.json", "r")
    local GAME_USER = json.decode(file:read("*a"))
    file:close()

    local user = GAME_USER[uid]
    local t = {}
    if user~=nil then
        t['code']=0
        t['info']=user
    else
        t['code']=1
        t['msg']='miss user'
    end
    return json.encode(t)
end

function game_user_free(p)
    local uid = p['uid']
    file = io.open("game_user.json", "r")
    local GAME_USER = json.decode(file:read("*a"))
    file:close()

    local user = GAME_USER[uid]
    local t = {}
    if user~=nil then
        GAME_USER[uid]=nil

        file = io.open("game_user.json", "w+")
        file:write(json.encode(GAME_USER))
        file:close()

        t['code']=0
        t['msg']='ok'
    else
        t['code']=1
        t['msg']='miss user'
    end
    return json.encode(t)
end
