require'resource/base64'
require'resource/common'
require'usdkLib/utils'
local json = loadfile("resource/json.lua")()

local productId = "获取方式请参考接入文档";
local productKey = "获取方式请参考接入文档";
local callbackKey = "获取方式请参考接入文档";
local checkUserUrl = "https://uglobal.ultrasdk.com/hu/v1/login/checkUserInfo.lg";

function usdk_login(cUid, cName, accessToken)
	local data = _markData(string.format([[{"cUid":"%s","'cName'":"%s","accessToken":"%s"}]],cUid,cName,accessToken))
	local timestamp = currTimestamp_seconds() .. ""

	local signKeys={"pcode","data","timestamp"}
	local signTable = {}
	signTable["pcode"] = productId
	signTable["data"] = data
	signTable["timestamp"] = timestamp
	local sign = markSign(productKey, signTable, signKeys)

	function call()
		print('--call start--')
		-- 请求参数不支持中文
		local formData = string.format("pcode=%s&data=%s&timestamp=%s&sign=%s",productId,data,timestamp,sign)
		local resp = net_post(checkUserUrl, formData)
		print('--call end--')
		return json.decode(resp)
	end
	function callFailed(err)
		-- print(err)
		return err
	end

    return xpcall( call, callFailed )
end

function usdk_payCallback(data, sign)
    if string.find(data, "%%") ~= nil then data = urlDecode(data) end
	if string.find(sign, "%%") ~= nil then sign = urlDecode(sign) end

	local signKeys={"data"}
	local signTable = {}
	signTable["data"] = data
	local dataSign = markSign(callbackKey, signTable, signKeys)
	if dataSign ~= sign then
		return nil
	end
	return json.decode(dec(data))
end

function urlEncode(s)
	s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)
   return string.gsub(s, " ", "+")
end

function urlDecode(s)
   s = string.gsub(s, '%%(%x%x)', function(h) return string.char(tonumber(h, 16)) end)
   return s
end
