require'resource/base64'
local md5 = require 'md5'
local json = loadfile("resource/json.lua")()

function markData(table)
    local jsonStr = json.encode(table)
    return _markData(jsonStr)
end

function _markData(jsonStr)
    -- print(jsonStr)
    local tmpData = enc(jsonStr)

    if string.len(tmpData)>51 then
        return changeArr(tmpData , {1, 33, 10, 42, 18, 50, 19, 51})
    else
        return tmpData
    end
end

function changeArr(arr, index)
    -- print(arr)
    for i = 1, #index, 2 do
        -- lua从1开始，所以+1与其他语言匹配
        local l = index[i] + 1
        local r = index[i+1] + 1
        arr = changeIdx(arr,l,r)
    end
    return arr
end

function changeIdx(arr, i, j)
    local x = string.sub(arr,i,i)
    local y = string.sub(arr,j,j)
    -- print(x..y)
    local idx = {i, j}
    table.sort(idx)
    arr = string.sub(arr,1,idx[1]-1) .. y .. string.sub(arr,idx[1]+1,idx[2]-1) .. x .. string.sub(arr,idx[2]+1)
    -- print(arr)
    return arr
end

function markSign(productKey, signTable, signKeys)
    table.sort(signKeys)
    local res=""
    for k,v in ipairs(signKeys) do
        if v~="sign" then
            res = res .. v .. "=" .. signTable[v] .. "&"
        end
    end
    res = res .. productKey
-- local md5_as_data  = md5.sum(message)       -- returns raw bytes
-- local md5_as_hex   = md5.sumhexa(message)   -- returns a hex string
-- local md5_as_hex2  = md5.tohex(md5_as_data) -- returns the same string as md5_as_hex
    return md5.sumhexa(res)
end

function net_post(url, formdata)
    local u = string.format("%s?%s",url,formdata)
    -- print(u)
    local uri = assert(u, "URI needed")
    local req_body = ''
    local req_timeout = 10

    local request = require "http.request"

    local req = request.new_from_uri(uri)
    if req_body then
        req.headers:upsert(":method", "POST")
        req:set_body(req_body)
    end

    print("# REQUEST")
    print("## HEADERS")
    for k, v in req.headers:each() do
        print(k, v)
    end
    print()
    if req.body then
        print("## BODY")
        print(req.body)
        print()
    end

    print("# RESPONSE")
    local headers, stream = req:go(req_timeout)
    if headers == nil then
        io.stderr:write(tostring(stream), "\n")
        os.exit(1)
    end
    print("## HEADERS")
    for k, v in headers:each() do
        print(k, v)
    end
    print()
    print("## BODY")
    local body, err = stream:get_body_as_string()
    if not body and err then
        io.stderr:write(tostring(err), "\n")
        os.exit(1)
    end
    print('body::'..body)
    print()
    return body
end
